--******************************************************************************
--*
--*  s_Rect struct
--*  by Ofer Zelichover (c) 12/2004
--*  http://tdp.nu/ofer/ ; ofer_z@hotmail.com
--*
--******************************************************************************
--*  You may use this script freely as you see fit.
--*  You may use parts or the script as a whole in your own scripts.
--*  (it would be nice if you give me a creadit if you do so ;))
--******************************************************************************
--*  This script comes with no warranty.
--*  I cannot be held responsible for any loss of data, time or any other
--*  damage or loss due to the use of this code.
--*
--*  ********************************************************************
--*  *** IF YOU DON'T LIKE THE ABOVE STATEMENT, DON'T USE THIS SCRIPT ***
--*  ********************************************************************
--*
--*  **** This script was written for max 7 and wasn't tested on other   ****
--*  **** vertions of max.                                               ****
--*
--*  If you find any bugs in it please let me know.
--******************************************************************************
--* Description
--* -------------
--*  this a struct for functions related to rectangles.
--*
--******************************************************************************




struct s_rect (
	ul, lr,
	fn width=(abs(lr.x-ul.x)), 
	fn height=(abs(ul.y-lr.y)), 
	fn size=(point2 self.width self.height),
	-- check if pos is inside rect
	fn isInside pos = (pos.x>=ul.x and pos.y>=ul.y and pos.x<=lr.x and pos.y<=lr.y),
	fn keepInside pos = (
		local tmpPos = pos
		if pos.x<ul.x then tmpPos.x = ul.x
		if pos.x>lr.x then tmpPos.x = lr.x
		if pos.y<ul.y then tmpPos.y = ul.y
		if pos.y>lr.y then tmpPos.y = lr.y
		tmpPos
	)
) -- end of s_rect struct 